#hardcode if you're not in the correct package instance...

#set package_id [ad_conn package_id]
set package_id 3409

set olddb [ns_db gethandle acs32]

set n_tried_old 0

set selection [ns_db select $olddb " 
select user_id, thread_id 
from bboard_thread_email_alerts
order by thread_id"]

set thread_mapping_sql "
select new_message_id as new_thread_id from migr_message_map
where old_message_id = :thread_id 
  and package_id = :package_id"

set user_mapping_sql "
select new_user_id from migr_user_map
where old_user_id = :user_id 
"


#note: no migr_map neccessary for subscriptions
# or even possible -- covered by user and topic map

set mapped_subs_sql  "
select thread_id || '-' || subscriber_id as new_map_id
 from bboard_thread_subscribers
where thread_id = :new_thread_id
and subscriber_id = :new_user_id"

set map_subs_sql "
insert into bboard_thread_subscribers
(thread_id, subscriber_id) values 
(:new_thread_id, :new_user_id)"

set nil [set new [list]]
set output ""

db_transaction {
while { [ns_db getrow $olddb $selection] } {
    set_variables_after_query
    
    #also lookup thread and user mapping
    db_1row q $thread_mapping_sql
    db_1row q $user_mapping_sql

    incr n_tried_old

    if [db_0or1row r $mapped_subs_sql] {
	##already mapped, sets new_map_id
	set new_id $new_map_id
	set action "nil"
    } else {
	#it's new; insert it.
	db_dml q $map_subs_sql
	set new_id "$new_thread_id-$new_user_id"
	set action "new"
    }

    set html "
    thread-user: $new_id
     <br>"

    lappend $action $html
    
    append output "<b>$action</b>:  $html"

}
} on_error {
    set output "<h3>Error:</h3><pre>$errmsg</pre><br><br>$output"
}

ns_db releasehandle $olddb
    
ns_return 200 text/html "<html>
<head><title>Migratonisubscripforum</title></head>
<body><h3> Migrating Forum Subscrtiptions</h3><p>
<h3>Unsorted Output:</h3>$output<br><h3>Sorted Output:</h3>
<h3>[llength $nil] nil -- categorys already created & mapped</h3><p>[join $nil]</p>
<h3>[llength $new] new -- uncreated and unmapped</h3><p>[join $new]</p>
</body></html>
"


    
    
